diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
index 057e81576..7aa17e976 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
@@ -5,18 +5,28 @@ import net.minecraft.client.render.LightingCache;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColor;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.block.model.BlockModel;
-import net.minecraft.client.render.block.model.BlockModelStandard;
+import net.minecraft.client.render.block.model.generic.BlockModelGeneric;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2f;
+import org.joml.Vector2fc;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.Vector3f;
+import org.joml.Vector3fc;
+import org.lwjgl.opengl.GL41;
 import org.useless.dragonfly.DisplayPos;
 import org.useless.dragonfly.data.block.mojang.BlockModelMojangData;
 import org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData;
@@ -26,145 +36,211 @@ import org.useless.dragonfly.models.block.StaticBlockModel;
 import java.util.Locale;
 
 import static net.minecraft.client.render.block.model.BlockModel.FULL_CUBE_THRESHOLD;
-import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.FLOATS_PER_NORMAL;
-import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.FLOATS_PER_VERTEX;
-import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.NORMAL_FLOAT_X;
-import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.NORMAL_FLOAT_Y;
-import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.NORMAL_FLOAT_Z;
 import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.VERTEX_BOTTOM_LEFT;
 import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.VERTEX_BOTTOM_RIGHT;
-import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.VERTEX_FLOAT_U;
-import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.VERTEX_FLOAT_V;
-import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.VERTEX_FLOAT_X;
-import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.VERTEX_FLOAT_Y;
-import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.VERTEX_FLOAT_Z;
+import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.VERTEX_TOP_LEFT;
 import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.VERTEX_TOP_RIGHT;
 
 public class StaticBlockModelMojang implements StaticBlockModel {
     protected static final Minecraft MC = Minecraft.getMinecraft();
     protected static final LightingCache LIGHTING_CACHE = new LightingCache();
 
-    protected static final byte[] V_TOP_X = new byte[]{0, 0, -1, 0, 0, 0};
-    protected static final byte[] V_TOP_Y = new byte[]{0, 0, 0, 1, 0, 0};
-    protected static final byte[] V_TOP_Z = new byte[]{1, 1, 0, 0, 1, 1};
+    protected final @NotNull CompiledBlockModelMojangData compiled;
 
-    protected static final byte[] V_LEF_X = new byte[]{-1, 1, 0, -1, 0, 0};
-    protected static final byte[] V_LEF_Y = new byte[]{0, 0, 1, 0, 1, -1};
-    protected static final byte[] V_LEF_Z = new byte[]{0, 0, 0, 0, 0, 0};
-
-    protected final CompiledBlockModelMojangData compiled;
-
-    public StaticBlockModelMojang(BlockModelMojangData data) {
+    public StaticBlockModelMojang(@NotNull BlockModelMojangData data) {
         this.compiled = new CompiledBlockModelMojangData(data);
     }
 
     @Override
-    public boolean renderStandalone(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull TessellatorGeneral tessellator, double x, double y, double z, int metadata, @NotNull BlockColor color) {
+    public boolean renderStandalone(@NotNull BlockModelGeneric<? extends BlockLogic> sourceModel, @NotNull TessellatorGeneral tessellator, double x, double y, double z, int metadata, int lightmapCoord, @NotNull BlockColor color) {
         if (this.compiled.elements.length == 0) return false;
 
         GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.TERRAIN);
+        GL41.glActiveTexture(GL41.GL_TEXTURE2);
+        TextureRegistry.worldAtlas.layerTextureMap.get("emissive").bind();
+//        GL41.glActiveTexture(GL41.GL_TEXTURE3);
+//        TextureRegistry.worldAtlas.layerTextureMap.get("maskColor").bind();
+        GL41.glActiveTexture(GL41.GL_TEXTURE0);
+        tessellator.startDrawingQuads();
         for (int i = 0; i < this.compiled.elements.length; i++) {
             C_Element element = this.compiled.elements[i];
 
-            GLRenderer.globalSetLightEnabled(element.shade);
-
-            tessellator.startDrawingQuads();
+            tessellator.setColor1i(0xFFFFFFFF);
+            tessellator.setLightmapCoord1i(lightmapCoord);
             for (int face = 0; face < element.faces; face++) {
-                IconCoordinate coordinate = this.compiled.textures.getOrDefault(element.textures[face], BlockModelStandard.BLOCK_TEXTURE_UNASSIGNED);
+                IconCoordinate coordinate = element.textures[face];
 
-                GLRenderer.setLightmapCoord2i(15, 15);
                 if (element.tintIndices[face] >= 0) {
                     tessellator.setColor1i(color.getFallbackColor(metadata, element.tintIndices[face]));
+                } else {
+                    tessellator.setColor1i(0xFFFFFFFF);
                 }
 
-                final int offset = face * 4 * FLOATS_PER_VERTEX;
+                final int offset = face * 4;
                 for (int v = 0; v < 4; v++) {
-                    tessellator.setNormal(element.normalData[face * FLOATS_PER_NORMAL + NORMAL_FLOAT_X], element.normalData[face * FLOATS_PER_NORMAL + NORMAL_FLOAT_Y], element.normalData[face * FLOATS_PER_NORMAL + NORMAL_FLOAT_Z]);
+                    if (element.shade) {
+                        Vector3fc normal = element.faceNormals[face];
+                        tessellator.setNormal(normal.x(), normal.y(), normal.z());
+                    } else {
+                        tessellator.setNormal(0, 1, 0);
+                    }
+                    Vector3dc pos = element.vertexPoses[offset + v];
+                    Vector2fc uvs = element.vertexUvs[offset + v];
                     tessellator.addVertexWithUV(
-                        element.vertexData[offset + v * FLOATS_PER_VERTEX + VERTEX_FLOAT_X] - 0.5f,
-                        element.vertexData[offset + v * FLOATS_PER_VERTEX + VERTEX_FLOAT_Y] - 0.5f,
-                        element.vertexData[offset + v * FLOATS_PER_VERTEX + VERTEX_FLOAT_Z] - 0.5f,
-                        coordinate.getSubIconU(element.vertexData[offset + v * FLOATS_PER_VERTEX + VERTEX_FLOAT_U]),
-                        coordinate.getSubIconV(element.vertexData[offset + v * FLOATS_PER_VERTEX + VERTEX_FLOAT_V]));
+                        pos.x() - 0.5f,
+                        pos.y() - 0.5f,
+                        pos.z() - 0.5f,
+                        coordinate.getSubIconU(uvs.x()),
+                        coordinate.getSubIconV(uvs.y()));
                 }
             }
-            tessellator.draw();
         }
+        tessellator.draw();
         GLRenderer.popFrame();
         return true;
     }
 
     @Override
-    public boolean renderAttached(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, int x, int y, int z, double xOff, double yOff, double zOff, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+    public boolean renderAttached(@NotNull BlockModelGeneric<? extends BlockLogic> sourceModel, @NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc blockPos, int rotX, int rotY, int rotZ, double xOff, double yOff, double zOff, boolean uvlock, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
         if (this.compiled.elements.length == 0) return false;
         boolean didRender = false;
-        LIGHTING_CACHE.setupCache(sourceModel.block, worldSource, x, y, z);
+        LIGHTING_CACHE.setupCache(sourceModel.block, worldSource, blockPos);
+        byte cullCache = 0;
 
         BlockColor color = BlockColorDispatcher.getInstance().getDispatch(sourceModel.block);
         for (int i = 0; i < this.compiled.elements.length; i++) {
             final C_Element element = this.compiled.elements[i];
             for (int face = 0; face < element.faces; face++) {
-                if (cullFaces && cullSide(worldSource, x, y, z, element.cullfaces[face])) continue;
-                final IconCoordinate coordinate = overrideTexture == null ? this.compiled.textures.getOrDefault(element.textures[face], BlockModelStandard.BLOCK_TEXTURE_UNASSIGNED) : overrideTexture;
-                final Direction direction = element.directions[face];
+                Direction cullDir = element.cullfaces[face];
+                if (cullFaces && cullDir != null) {
+                    cullDir = Direction.rotateZ(Direction.rotateY(Direction.rotateX(element.cullfaces[face], rotX), rotY), rotZ);
+                    if ((cullCache & (1 << cullDir.getId())) != 0) {
+                        continue;
+                    }
+                    if (sourceModel.cullSide(worldSource, blockPos, cullDir)) {
+                        cullCache |= (byte) (1 << cullDir.getId());
+                        continue;
+                    }
+                }
+                final IconCoordinate coordinate = overrideTexture == null ? element.textures[face] : overrideTexture;
+                Direction direction = Direction.rotateZ(Direction.rotateY(Direction.rotateX(element.directions[face], rotX), rotY), rotZ);
 
                 final float minBrightness = element.lightEmission / 15f;
 
-                final int topX = V_TOP_X[direction.getId()];
-                final int topY = V_TOP_Y[direction.getId()];
-                final int topZ = V_TOP_Z[direction.getId()];
-                final float topP;
-                final float botP;
-                final int lefX = V_LEF_X[direction.getId()];
-                final int lefY = V_LEF_Y[direction.getId()];
-                final int lefZ = V_LEF_Z[direction.getId()];
-                final float lefP;
-                final float rigP;
-                final float depth;
-                switch (direction) {
-                    case DOWN:
-                        depth = 0 + element.minY;
-                        topP = element.maxZ;
-                        botP = element.minZ;
-                        lefP = 1 - element.minX;
-                        rigP = 1 - element.maxX;
-                        break;
-                    case UP:
-                        depth = 1 - element.maxY;
-                        topP = element.maxZ;
-                        botP = element.minZ;
-                        lefP = element.maxX;
-                        rigP = element.minX;
-                        break;
-                    case NORTH:
-                        depth = 0 + element.minZ;
-                        topP = 1 - element.minX;
-                        botP = 1 - element.maxX;
-                        lefP = element.maxY;
-                        rigP = element.minY;
-                        break;
-                    case SOUTH:
-                        depth = 1 - element.maxZ;
-                        topP = element.maxY;
-                        botP = element.minY;
-                        lefP = 1 - element.minX;
-                        rigP = 1 - element.maxX;
-                        break;
-                    case WEST:
-                        depth = 0 + element.minX;
-                        topP = element.maxZ;
-                        botP = element.minZ;
-                        lefP = element.maxY;
-                        rigP = element.minY;
-                        break;
-                    case EAST:
-                    default:
-                        depth = 1 - element.maxX;
-                        topP = element.maxZ;
-                        botP = element.minZ;
-                        lefP = 1 - element.minY;
-                        rigP = 1 - element.maxY;
-                        break;
+                Vector3f q = new Vector3f();
+                final Vector3f top = q.set(element.faceUps[face]);
+                if (rotX != 0) { top.rotateX(rotX * org.joml.Math.PI_OVER_2_f); }
+                if (rotY != 0) { top.rotateY(rotY * org.joml.Math.PI_OVER_2_f); }
+                if (rotZ != 0) { top.rotateZ(rotZ * org.joml.Math.PI_OVER_2_f); }
+                final int topX = org.joml.Math.round(top.x());
+                final int topY = org.joml.Math.round(top.y());
+                final int topZ = org.joml.Math.round(top.z());
+                float topP;
+                float botP;
+
+                final Vector3f left = q.set(element.faceLefts[face]);
+                if (rotX != 0) { left.rotateX(rotX * org.joml.Math.PI_OVER_2_f); }
+                if (rotY != 0) { left.rotateY(rotY * org.joml.Math.PI_OVER_2_f); }
+                if (rotZ != 0) { left.rotateZ(rotZ * org.joml.Math.PI_OVER_2_f); }
+                final int lefX = org.joml.Math.round(left.x());
+                final int lefY = org.joml.Math.round(left.y());
+                final int lefZ = org.joml.Math.round(left.z());
+                float lefP;
+                float rigP;
+                float depth;
+                if (element.flip) {
+                    switch (element.directions[face]) {
+                        case DOWN:
+                            depth = 1 - element.minY;
+                            topP = element.maxZ;
+                            botP = element.minZ;
+                            lefP = 1 - element.minX;
+                            rigP = 1 - element.maxX;
+                            break;
+                        case UP:
+                            depth = 0 + element.maxY;
+                            topP = element.maxZ;
+                            botP = element.minZ;
+                            lefP = element.maxX;
+                            rigP = element.minX;
+                            break;
+                        case NORTH:
+                            depth = 1 - element.minZ;
+                            topP = 1 - element.minX;
+                            botP = 1 - element.maxX;
+                            lefP = element.maxY;
+                            rigP = element.minY;
+                            break;
+                        case SOUTH:
+                            depth = 0 + element.maxZ;
+                            topP = element.maxY;
+                            botP = element.minY;
+                            lefP = 1 - element.minX;
+                            rigP = 1 - element.maxX;
+                            break;
+                        case WEST:
+                            depth = 1 - element.maxX;
+                            topP = element.maxZ;
+                            botP = element.minZ;
+                            lefP = element.maxY;
+                            rigP = element.minY;
+                            break;
+                        case EAST:
+                        default:
+                            depth = 0 + element.minX;
+                            topP = element.maxZ;
+                            botP = element.minZ;
+                            lefP = 1 - element.minY;
+                            rigP = 1 - element.maxY;
+                            break;
+                    }
+                } else {
+                    switch (element.directions[face]) {
+                        case DOWN:
+                            depth = 0 + element.minY;
+                            topP = element.maxZ;
+                            botP = element.minZ;
+                            lefP = 1 - element.minX;
+                            rigP = 1 - element.maxX;
+                            break;
+                        case UP:
+                            depth = 1 - element.maxY;
+                            topP = element.maxZ;
+                            botP = element.minZ;
+                            lefP = element.maxX;
+                            rigP = element.minX;
+                            break;
+                        case NORTH:
+                            depth = 0 + element.minZ;
+                            topP = 1 - element.minX;
+                            botP = 1 - element.maxX;
+                            lefP = element.maxY;
+                            rigP = element.minY;
+                            break;
+                        case SOUTH:
+                            depth = 1 - element.maxZ;
+                            topP = element.maxY;
+                            botP = element.minY;
+                            lefP = 1 - element.minX;
+                            rigP = 1 - element.maxX;
+                            break;
+                        case WEST:
+                            depth = 0 + element.minX;
+                            topP = element.maxZ;
+                            botP = element.minZ;
+                            lefP = element.maxY;
+                            rigP = element.minY;
+                            break;
+                        case EAST:
+                        default:
+                            depth = 1 - element.maxX;
+                            topP = element.maxZ;
+                            botP = element.minZ;
+                            lefP = 1 - element.minY;
+                            rigP = 1 - element.maxY;
+                            break;
+                    }
                 }
 
                 final boolean useAO = this.compiled.data.ambientOcclusion && MC.isAmbientOcclusionEnabled() && element.shade;
@@ -174,7 +250,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 final float g;
                 final float b;
                 if (element.tintIndices[face] >= 0) {
-                    int c = color.getWorldColor(worldSource, x, y, z, element.tintIndices[face]);
+                    int c = color.getWorldColor(worldSource, blockPos, element.tintIndices[face]);
                     r = Color.redFromInt(c) / 255f;
                     g = Color.greenFromInt(c) / 255f;
                     b = Color.blueFromInt(c) / 255f;
@@ -184,9 +260,9 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                     b = 1;
                 }
 
-                final int dirX = direction.getOffsetX();
-                final int dirY = direction.getOffsetY();
-                final int dirZ = direction.getOffsetZ();
+                final int dirX = element.flip ? -direction.getOffsetX() : direction.getOffsetX();
+                final int dirY = element.flip ? -direction.getOffsetY() : direction.getOffsetY();
+                final int dirZ = element.flip ? -direction.getOffsetZ() : direction.getOffsetZ();
 
                 final int lightmapCoordTopLeft;
                 final int lightmapCoordBottomLeft;
@@ -343,44 +419,96 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 colorGreenTopRight *= ltr;
                 colorBlueTopRight *= ltr;
 
-                final int offset = face * 4 * FLOATS_PER_VERTEX;
+                final int offset = face * 4;
 
-                tessellator.setNormal(direction.getOffsetX(), direction.getOffsetY(), direction.getOffsetZ());
+                Vector3f norm = q.set(element.faceNormals[face]);
+                if (rotX != 0) { norm.rotateX(rotX * org.joml.Math.PI_OVER_2_f); }
+                if (rotY != 0) { norm.rotateY(rotY * org.joml.Math.PI_OVER_2_f); }
+                if (rotZ != 0) { norm.rotateZ(rotZ * org.joml.Math.PI_OVER_2_f); }
+
+                if (element.shade) {
+                    tessellator.setNormal(norm.x(), norm.y(), norm.z());
+                } else {
+                    tessellator.setNormal(0, 1, 0);
+                }
+
+                Vector3d v = new Vector3d();
+
+                Vector3d posTL = v.set(element.vertexPoses[offset + VERTEX_TOP_LEFT]);
+                if (rotX != 0 || rotY != 0 || rotZ != 0) {
+                    posTL.sub(0.5, 0.5, 0.5)
+                        .rotateX(rotX * org.joml.Math.PI_OVER_2)
+                        .rotateY(rotY * org.joml.Math.PI_OVER_2)
+                        .rotateZ(rotZ * org.joml.Math.PI_OVER_2)
+                        .add(0.5, 0.5, 0.5);
+                }
+                Vector2fc uvsTL = element.vertexUvs[offset + VERTEX_TOP_LEFT];
+                if (uvlock) uvsTL = rotateUV(uvsTL, rotX, rotY, rotZ, element.directions[face], new Vector2f());
                 tessellator.setColorOpaque3f(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
                 tessellator.setLightmapCoord1i(lightmapCoordTopLeft);
                 tessellator.addVertexWithUV(
-                    element.vertexData[offset + VERTEX_FLOAT_X] + x + xOff,
-                    element.vertexData[offset + VERTEX_FLOAT_Y] + y + yOff,
-                    element.vertexData[offset + VERTEX_FLOAT_Z] + z + zOff,
-                    coordinate.getSubIconU(element.vertexData[offset + VERTEX_FLOAT_U]),
-                    coordinate.getSubIconV(element.vertexData[offset + VERTEX_FLOAT_V]));
-
+                    posTL.x() + blockPos.x() + xOff,
+                    posTL.y() + blockPos.y() + yOff,
+                    posTL.z() + blockPos.z() + zOff,
+                    coordinate.getSubIconU(uvsTL.x()),
+                    coordinate.getSubIconV(uvsTL.y()));
+
+                Vector3d posBL = v.set(element.vertexPoses[offset + VERTEX_BOTTOM_LEFT]);
+                if (rotX != 0 || rotY != 0 || rotZ != 0) {
+                    posBL.sub(0.5, 0.5, 0.5)
+                        .rotateX(rotX * org.joml.Math.PI_OVER_2)
+                        .rotateY(rotY * org.joml.Math.PI_OVER_2)
+                        .rotateZ(rotZ * org.joml.Math.PI_OVER_2)
+                        .add(0.5, 0.5, 0.5);
+                }
+                Vector2fc uvsBL = element.vertexUvs[offset + VERTEX_BOTTOM_LEFT];
+                if (uvlock) uvsBL = rotateUV(uvsBL, rotX, rotY, rotZ, element.directions[face], new Vector2f());
                 tessellator.setColorOpaque3f(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
                 tessellator.setLightmapCoord1i(lightmapCoordBottomLeft);
                 tessellator.addVertexWithUV(
-                    element.vertexData[offset + VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX + VERTEX_FLOAT_X] + x + xOff,
-                    element.vertexData[offset + VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX + VERTEX_FLOAT_Y] + y + yOff,
-                    element.vertexData[offset + VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX + VERTEX_FLOAT_Z] + z + zOff,
-                    coordinate.getSubIconU(element.vertexData[offset + VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX + VERTEX_FLOAT_U]),
-                    coordinate.getSubIconV(element.vertexData[offset + VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX + VERTEX_FLOAT_V]));
-
+                    posBL.x() + blockPos.x() + xOff,
+                    posBL.y() + blockPos.y() + yOff,
+                    posBL.z() + blockPos.z() + zOff,
+                    coordinate.getSubIconU(uvsBL.x()),
+                    coordinate.getSubIconV(uvsBL.y()));
+
+                Vector3d posBR = v.set(element.vertexPoses[offset + VERTEX_BOTTOM_RIGHT]);
+                if (rotX != 0 || rotY != 0 || rotZ != 0) {
+                    posBR.sub(0.5, 0.5, 0.5)
+                        .rotateX(rotX * org.joml.Math.PI_OVER_2)
+                        .rotateY(rotY * org.joml.Math.PI_OVER_2)
+                        .rotateZ(rotZ * org.joml.Math.PI_OVER_2)
+                        .add(0.5, 0.5, 0.5);
+                }
+                Vector2fc uvsBR = element.vertexUvs[offset + VERTEX_BOTTOM_RIGHT];
+                if (uvlock) uvsBR = rotateUV(uvsBR, rotX, rotY, rotZ, element.directions[face], new Vector2f());
                 tessellator.setColorOpaque3f(colorRedBottomRight, colorGreenBottomRight, colorBlueBottomRight);
                 tessellator.setLightmapCoord1i(lightmapCoordBottomRight);
                 tessellator.addVertexWithUV(
-                    element.vertexData[offset + VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX + VERTEX_FLOAT_X] + x + xOff,
-                    element.vertexData[offset + VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX + VERTEX_FLOAT_Y] + y + yOff,
-                    element.vertexData[offset + VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX + VERTEX_FLOAT_Z] + z + zOff,
-                    coordinate.getSubIconU(element.vertexData[offset + VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX + VERTEX_FLOAT_U]),
-                    coordinate.getSubIconV(element.vertexData[offset + VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX + VERTEX_FLOAT_V]));
-
+                    posBR.x() + blockPos.x() + xOff,
+                    posBR.y() + blockPos.y() + yOff,
+                    posBR.z() + blockPos.z() + zOff,
+                    coordinate.getSubIconU(uvsBR.x()),
+                    coordinate.getSubIconV(uvsBR.y()));
+
+                Vector3d posTR = v.set(element.vertexPoses[offset + VERTEX_TOP_RIGHT]);
+                if (rotX != 0 || rotY != 0 || rotZ != 0) {
+                    posTR.sub(0.5, 0.5, 0.5)
+                        .rotateX(rotX * org.joml.Math.PI_OVER_2)
+                        .rotateY(rotY * org.joml.Math.PI_OVER_2)
+                        .rotateZ(rotZ * org.joml.Math.PI_OVER_2)
+                        .add(0.5, 0.5, 0.5);
+                }
+                Vector2fc uvsTR = element.vertexUvs[offset + VERTEX_TOP_RIGHT];
+                if (uvlock) uvsTR = rotateUV(uvsTR, rotX, rotY, rotZ, element.directions[face], new Vector2f());
                 tessellator.setColorOpaque3f(colorRedTopRight, colorGreenTopRight, colorBlueTopRight);
                 tessellator.setLightmapCoord1i(lightmapCoordTopRight);
                 tessellator.addVertexWithUV(
-                    element.vertexData[offset + VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX + VERTEX_FLOAT_X] + x + xOff,
-                    element.vertexData[offset + VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX + VERTEX_FLOAT_Y] + y + yOff,
-                    element.vertexData[offset + VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX + VERTEX_FLOAT_Z] + z + zOff,
-                    coordinate.getSubIconU(element.vertexData[offset + VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX + VERTEX_FLOAT_U]),
-                    coordinate.getSubIconV(element.vertexData[offset + VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX + VERTEX_FLOAT_V]));
+                    posTR.x() + blockPos.x() + xOff,
+                    posTR.y() + blockPos.y() + yOff,
+                    posTR.z() + blockPos.z() + zOff,
+                    coordinate.getSubIconU(uvsTR.x()),
+                    coordinate.getSubIconV(uvsTR.y()));
 
                 tessellator.setNormal(0, 1, 0);
                 didRender = true;
@@ -389,6 +517,75 @@ public class StaticBlockModelMojang implements StaticBlockModel {
         return didRender;
     }
 
+    public @NotNull Vector2f rotateUV(@NotNull Vector2fc uvs, int rotX, int rotY, int rotZ, @NotNull Direction srcDirection, @NotNull Vector2f dest) {
+        Direction dir = srcDirection;
+        float u = uvs.x() - 0.5f;
+        float v = uvs.y() - 0.5f;
+        rotX = (rotX & 0b11);
+        while (rotX > 0) {
+            if (dir.getAxis() == Axis.X) {
+                if (dir == Direction.WEST) {
+                    float _u = u;
+                    u = -v;
+                    v = _u;
+                } else {
+                    float _u = u;
+                    u = v;
+                    v = -_u;
+                }
+            } else {
+                if (dir == Direction.NORTH || dir == Direction.DOWN) {
+                    v = -v;
+                    u = -u;
+                }
+            }
+            dir = Direction.rotateX(dir, 1);
+            rotX--;
+        }
+
+        rotY = (rotY & 0b11);
+        while (rotY > 0) {
+            if (dir.getAxis() == Axis.Y) {
+                if (dir == Direction.DOWN) {
+                    float _v = v;
+                    v = u;
+                    u = -_v;
+                } else {
+                    float _u = u;
+                    u = v;
+                    v = -_u;
+                }
+            }
+            dir = Direction.rotateY(dir, 1);
+            rotY--;
+        }
+
+        rotZ = (rotZ & 0b11);
+        while (rotZ > 0) {
+            if (dir.getAxis() == Axis.Z) {
+                if (dir == Direction.NORTH) {
+                    float _u = u;
+                    u = -v;
+                    v = _u;
+                } else {
+                    float _u = u;
+                    u = v;
+                    v = -_u;
+                }
+            } else {
+                if (dir == Direction.DOWN || dir == Direction.UP || dir == Direction.WEST || dir == Direction.EAST) {
+                    float _v = v;
+                    v = -u;
+                    u = _v;
+                }
+            }
+            dir = Direction.rotateZ(dir, 1);
+            rotZ--;
+        }
+
+        return dest.set(u + 0.5f, v + 0.5f);
+    }
+
     @Override
     public @Nullable IconCoordinate getOverlay() {
         // This breaks the modern mc format of using the "#particle" symbol for the overlay, but due to our changes to the spec this is the best way of going about it
@@ -415,10 +612,6 @@ public class StaticBlockModelMojang implements StaticBlockModel {
         return this.compiled.displayPosMap.getOrDefault(id, DisplayPos.DEFAULT_DISPLAY_POS);
     }
 
-    protected boolean cullSide(WorldSource worldSource, int x, int y, int z, @Nullable Direction direction) {
-        return direction != null && worldSource.isBlockOpaqueCube(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ());
-    }
-
     protected float getBrightness(int relX, int relY, int relZ, float min) {
         return Math.max(LIGHTING_CACHE.getBrightness(relX, relY, relZ), min);
     }
